<!--
  ~ Benchmarking Suite
  ~ Copyright 2014-2022 Engineering Ingegneria Informatica S.p.A.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~ http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->

<template>

  <v-container>
  
    <v-row dense>
      <v-col cols="6" >
         <v-select
          :items="providerTechnologies"
          label="Provider technology"
          v-model="provider.driver"
          :rules="technologyRules"
        ></v-select>
      </v-col>
    </v-row>
    <v-row
      dense
    >
      <v-col cols="6" >
        <v-text-field 
          label="Host" 
          hint="Endpoint of the vCloud installation"
          v-model="provider.host"
          :rules="hostRules"
        ></v-text-field>
      </v-col>
    </v-row>

    <v-row dense>
      <v-col cols="6" >
        <v-text-field 
          label="Organization" 
          hint="The organization the user belongs to"
          v-model="provider.organization"
          :rules="usernameRules"
        ></v-text-field>
      </v-col>
      <v-col cols="6" >
        <v-text-field 
          label="VDC" 
          hint="The name of the virtual data center"
          v-model="provider.vdc"
        ></v-text-field>
      </v-col>
    </v-row>
    <v-row dense>
      <v-col cols="6" >
        <v-text-field 
          label="Username" 
          hint="The username to use to connect"
          v-model="provider.user"
          :rules="usernameRules"
        ></v-text-field>
      </v-col>
      <v-col cols="6" >
        <v-text-field 
          label="Password" 
          hint="The password"
          type="password"
          v-model="provider.secret_password"
          :rules="passwordRules"
        ></v-text-field>
      </v-col>
    </v-row>
  </v-container>
</template>

<script>

export default {

  name: 'VMWareConnectionEditor',

  props: {
    provider: {
      type: Object,
      default: function() {return {}}
    },
    providerTechnologies: {
      type: Array,
      default: function() {return []}
    }
  },

  data: () => ({

    technologyRules: [
        v => !!v || 'A cloud provider technology must be selected'
      ],
    hostRules : [
        v => !!v || 'A connection host is required',
        v => (v && v.trim().length > 0) || 'A connection host is required'
      ],

    usernameRules : [
        v => !!v || (v && v.trim().length > 0) ||'A user name is required',
        v => (v && v.trim().length > 0) || 'A user name is required'
      ],

    passwordRules : [
        v => !!v || 'A password/secret is required'
      ]
  })
    
};

</script>

